---
title: IDBRequest.error
slug: Web/API/IDBRequest/error
tags:
  - API
  - Database
  - Error
  - IDBRequest
  - IndexedDB
  - Property
  - Reference
  - Storage
---
<p>{{ APIRef("IndexedDB") }}</p>

<div>
<p>The <strong><code>error</code></strong> read-only property of the {{domxref("IDBRequest")}} interface returns the error in the event of an unsuccessful request.</p>

<p>{{AvailableInWorkers}}</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>myError</em> = <em>request</em>.error;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMError")}} containing the relevant error. In Chrome 48+/Firefox 58+ this property returns a {{domxref("DOMException")}} because <code>DOMError</code> has been removed from the DOM standard. The following error codes are returned under certain conditions:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Error</th>
   <th scope="col">Explanation</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>AbortError</code></td>
   <td>If you abort the transaction, then all requests still in progress receive this error.</td>
  </tr>
  <tr>
   <td><code>ConstraintError</code></td>
   <td>If you insert data that doesn't conform to a constraint. It's an exception type for creating stores and indexes. You get this error, for example, if you try to add a new key that already exists in the record.</td>
  </tr>
  <tr>
   <td><code>QuotaExceededError</code></td>
   <td>If you run out of disk quota and the user declined to grant you more space.</td>
  </tr>
  <tr>
   <td><code>UnknownError</code></td>
   <td>If the operation failed for reasons unrelated to the database itself. A failure due to disk IO errors is such an example.</td>
  </tr>
  <tr>
   <td><code>NoError</code></td>
   <td>If the request succeeds.</td>
  </tr>
  <tr>
   <td><code>VersionError</code></td>
   <td>If you try to open a database with a version lower than the one it already has.</td>
  </tr>
 </tbody>
</table>

<p>In addition to the error codes sent to the {{ domxref("IDBRequest") }} object, asynchronous operations can also raise exceptions. The list describes problems that could occur when the request is being executed, but you might also encounter other problems when the request is being made. For example, if the request failed and the result is not available, the <span style="font-family: courier new,andale mono,monospace; line-height: normal;">InvalidStateError</span> exception is thrown.</p>

<h2 id="Example">Example</h2>

<p>The following example requests a given record title, <code>onsuccess</code> gets the associated record from the {{domxref("IDBObjectStore")}} (made available as <code style="font-style: normal;">objectStoreTitleRequest.result</code><span style="line-height: 1.5;">), updates one property of the record, and then puts the updated record back into the object store. Also included at the bottom is an <code>onerror</code> function that reports what the error was if the request fails. For a full working example, see our </span><a href="https://github.com/mdn/to-do-notifications/" style="line-height: 1.5;">To-do Notifications</a><span style="line-height: 1.5;"> app (</span><a href="https://mdn.github.io/to-do-notifications/" style="line-height: 1.5;">view example live</a><span style="line-height: 1.5;">.)</span></p>

<pre class="brush: js">var title = "Walk dog";

// Open up a transaction as usual
var objectStore = db.transaction(['toDoList'], "readwrite").objectStore('toDoList');

// Get the do-do list with the specified title
var objectStoreTitleRequest = objectStore.get(title);

objectStoreTitleRequest.onsuccess = function() {
  // Grab the data object returned as the result
  var data = objectStoreTitleRequest.result;

  // Update the notified value in the object to "yes"
  data.notified = "yes";

  // Create another request that inserts the item
  // back into the database
  var updateTitleRequest = objectStore.put(data);

  // When this new request succeeds, run the displayData()
  // function again to update the display
  updateTitleRequest.onsuccess = function() {
    displayData();
  };
};

<span style="font-size: 1rem;">objectStoreTitleRequest</span>.onerror = function() {
  // If an error occurs with the request, log what it is
  console.log("There has been an error with retrieving your data: " + <span style="font-size: 1rem;">objectStoreTitleRequest</span><span style="font-size: 1rem;">.error);</span>
};</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('IndexedDB', '#dom-idbrequest-error', 'error')}}</td>
   <td>{{Spec2('IndexedDB')}}</td>
   <td> </td>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 2", "#dom-idbrequest-error", "error")}}</td>
   <td>{{Spec2("IndexedDB 2")}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.IDBRequest.error")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
